unit ScanVision;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls,uInstrumental_Basico,uBitMap,uCamera,uTriangulo,
  uObjeto,uCena,uCoordenadas,uWireframe,uFlat_shading,uGouraud,uZ_buffer,
  Math,uPhong, ExtDlgs;

type
  TForm1 = class(TForm)
    Imagem: TImage;
    PageControl1: TPageControl;
    ParametrosCam_tabsheet: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    Label1: TLabel;
    Cx_edit: TEdit;
    Cy_edit: TEdit;
    Cz_edit: TEdit;
    Label2: TLabel;
    Nx_edit: TEdit;
    Ny_edit: TEdit;
    Nz_edit: TEdit;
    Label3: TLabel;
    Vx_edit: TEdit;
    Vy_edit: TEdit;
    Vz_edit: TEdit;
    Label4: TLabel;
    d_edit: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    hx_edit: TEdit;
    hy_edit: TEdit;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    IaRed_edit: TEdit;
    IaGreen_edit: TEdit;
    IaBlue_edit: TEdit;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Ka_edit: TEdit;
    FontesDeLuz_groupbox: TGroupBox;
    IlRed_edit: TEdit;
    IlGreen_edit: TEdit;
    IlBlue_edit: TEdit;
    Plx_edit: TEdit;
    Ply_edit: TEdit;
    Plz_edit: TEdit;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    RemoverFonte_button: TButton;
    AdicionarFonte_button: TButton;
    FontePrevia_button: TButton;
    FontePosterior_button: TButton;
    Label30: TLabel;
    OdiRed_edit: TEdit;
    Label31: TLabel;
    Label32: TLabel;
    OdiGreen_edit: TEdit;
    OdiBlue_edit: TEdit;
    Label33: TLabel;
    OsiRed_edit: TEdit;
    Label34: TLabel;
    OsiGreen_edit: TEdit;
    Label35: TLabel;
    Label36: TLabel;
    OsiBlue_edit: TEdit;
    Kd_edit: TEdit;
    Ks_edit: TEdit;
    Label37: TLabel;
    Label38: TLabel;
    Label39: TLabel;
    Label40: TLabel;
    Label41: TLabel;
    rugosidade_edit: TEdit;
    Desenhar_button: TButton;
    TabSheet4: TTabSheet;
    Renderizadores_radio: TRadioGroup;
    OpenDialog1: TOpenDialog;
    CarregarObj_button: TButton;
    NomeDoArquivo_label: TLabel;
    Objetoemuso_label: TLabel;
    Mensagem_label: TLabel;
    Label42: TLabel;
    OdeRed_edit: TEdit;
    OdeGreen_edit: TEdit;
    OdeBlue_edit: TEdit;
    Label43: TLabel;
    Label44: TLabel;
    Label45: TLabel;
    Label46: TLabel;
    OseRed_edit: TEdit;
    Label47: TLabel;
    OseGreen_edit: TEdit;
    Label48: TLabel;
    OseBlue_edit: TEdit;
    Label49: TLabel;
    Eixos_de_rotacao_radio: TRadioGroup;
    Label50: TLabel;
    Label51: TLabel;
    Centrox_edit: TEdit;
    Centroy_edit: TEdit;
    Centroz_edit: TEdit;
    Label52: TLabel;
    Label53: TLabel;
    Label54: TLabel;
    CarregarCtr_button: TButton;
    Angulo_edit: TEdit;
    Label55: TLabel;
    EfetuarRot_button: TButton;
    CarregarFoco_button: TButton;
    EfetuarRotDes_button: TButton;
    Button1: TButton;
    Button2: TButton;
    Label56: TLabel;
    SavePictureDialog1: TSavePictureDialog;
    Button3: TButton;
    Button4: TButton;
    Label57: TLabel;
    Label58: TLabel;
    Label59: TLabel;
    tFacei_edit: TEdit;
    Label60: TLabel;
    tFacef_edit: TEdit;
    Label61: TLabel;
    FatorDilZ: TEdit;
    TetCor_red: TEdit;
    TetCor_green: TEdit;
    TetCor_blue: TEdit;
    Label62: TLabel;
    NumTet: TLabel;
    Button5: TButton;
    Button6: TButton;
    THabil: TCheckBox;
    TModo: TCheckBox;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Button10: TButton;
    Button11: TButton;
    Button12: TButton;
    Button13: TButton;
    Button14: TButton;
    Button15: TButton;
    procedure atualiza_fonte_visivel;
    constructor create(AOwner:TComponent);override;
    procedure Desenhar_buttonClick(Sender: TObject);
    procedure CarregarObj_buttonClick(Sender: TObject);
    procedure carrega_configuracao;
    procedure descarrega_configuracao(Sender: TObject);
    procedure FontePrevia_buttonClick(Sender: TObject);
    procedure FontePosterior_buttonClick(Sender: TObject);
    procedure AdicionarFonte_buttonClick(Sender: TObject);
    procedure RemoverFonte_buttonClick(Sender: TObject);
    procedure CarregarCtr_buttonClick(Sender: TObject);
    procedure EfetuarRot_buttonClick(Sender: TObject);
    procedure CarregarFoco_buttonClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure EfetuarRotDes_buttonClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure TModoClick(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure TetCor_redChange(Sender: TObject);
    procedure TetCor_greenChange(Sender: TObject);
    procedure TetCor_blueChange(Sender: TObject);
    procedure THabilClick(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure Button15Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
  private
    { Private declarations }
  public
   { Public declarations }
  end;
  

var
  Form1: TForm1;
  LFontes:TStringList;
  Fonte_visivel:integer;
  diretorio:string;
  TetAtual:integer;


implementation

{$R *.DFM}


procedure TForm1.Desenhar_buttonClick(Sender: TObject);
var N,V:vetor;
    C:ponto;
    mens:string;
    d,hx,hy:real;
    cam:Camera;
    p:integer;
    erro:Boolean;
begin
  FatorDilatacaoZ:=obter_real(FatorDilZ.Text,erro);
  if erro then
     Mensagem_label.Caption:='Fator de Dilatao em formato invlido.'
  else
   case  Renderizadores_radio.ItemIndex of
      0:begin
           Mensagem_label.Caption:=prepara_camera(Nx_edit.Text,Ny_edit.Text,
               Nz_edit.Text,Vx_edit.Text,Vy_edit.Text,Vz_edit.Text,Cx_edit.Text,
               Cy_edit.Text,Cz_edit.Text,d_edit.Text,hx_edit.Text,hy_edit.Text);
           if Mensagem_label.Caption[1]=' ' then begin
              mundial_para_vista;
              Imagem.Picture.Bitmap:=wireframe;
           end;
        end;
      1:begin
           Mensagem_label.Caption:=prepara_camera(Nx_edit.Text,Ny_edit.Text,
               Nz_edit.Text,Vx_edit.Text,Vy_edit.Text,Vz_edit.Text,Cx_edit.Text,
               Cy_edit.Text,Cz_edit.Text,d_edit.Text,hx_edit.Text,hy_edit.Text);
           if Mensagem_label.Caption[1]=' ' then begin
              mundial_para_vista;
              Imagem.Picture.Bitmap:=wireframe_com_linhas_escondidas;
           end;
        end;
      2:begin
           Mensagem_label.Caption:=prepara_camera(Nx_edit.Text,Ny_edit.Text,
               Nz_edit.Text,Vx_edit.Text,Vy_edit.Text,Vz_edit.Text,Cx_edit.Text,
               Cy_edit.Text,Cz_edit.Text,d_edit.Text,hx_edit.Text,hy_edit.Text);
           if Mensagem_label.Caption[1]=' ' then begin
              Mensagem_label.Caption:=prepara_objeto(OdiRed_edit.Text,OdiGreen_edit.Text,
                  OdiBlue_edit.Text,OdeRed_edit.Text,OdeGreen_edit.Text,OdeBlue_edit.Text,
                  OsiRed_edit.Text,OsiGreen_edit.Text,OsiBlue_edit.Text,OseRed_edit.Text,
                  OseGreen_edit.Text,OseBlue_edit.Text,Kd_edit.Text,Ks_edit.Text,
                  rugosidade_edit.Text);
              if Mensagem_label.Caption[1]=' ' then begin
                 Mensagem_label.Caption:=prepara_cena(IaRed_edit.Text,IaGreen_edit.Text,
                                               IaBlue_edit.Text,Ka_edit.Text);
                 if Mensagem_label.Caption[1]=' ' then begin
                    atualiza_fonte_visivel;
                    Mensagem_label.Caption:=prepara_listas_das_fontes_de_luz(LFontes);
                    if Mensagem_label.Caption[1]=' ' then begin
                       mundial_para_vista;
                       mundial_para_vista_fontes_de_luz;
                       Imagem.Picture.Bitmap:=flat_shading;
                    end;
                 end;
              end;
           end;
        end;
      3:begin
           Mensagem_label.Caption:=prepara_camera(Nx_edit.Text,Ny_edit.Text,
               Nz_edit.Text,Vx_edit.Text,Vy_edit.Text,Vz_edit.Text,Cx_edit.Text,
               Cy_edit.Text,Cz_edit.Text,d_edit.Text,hx_edit.Text,hy_edit.Text);
           if Mensagem_label.Caption[1]=' ' then begin
              Mensagem_label.Caption:=prepara_objeto(OdiRed_edit.Text,OdiGreen_edit.Text,
                  OdiBlue_edit.Text,OdeRed_edit.Text,OdeGreen_edit.Text,OdeBlue_edit.Text,
                  OsiRed_edit.Text,OsiGreen_edit.Text,OsiBlue_edit.Text,OseRed_edit.Text,
                  OseGreen_edit.Text,OseBlue_edit.Text,Kd_edit.Text,Ks_edit.Text,
                  rugosidade_edit.Text);
              if Mensagem_label.Caption[1]=' ' then begin
                 Mensagem_label.Caption:=prepara_cena(IaRed_edit.Text,IaGreen_edit.Text,
                                               IaBlue_edit.Text,Ka_edit.Text);
                 if Mensagem_label.Caption[1]=' ' then begin
                    atualiza_fonte_visivel;
                    Mensagem_label.Caption:=prepara_listas_das_fontes_de_luz(LFontes);
                    if Mensagem_label.Caption[1]=' ' then begin
                       mundial_para_vista;
                       mundial_para_vista_fontes_de_luz;
                       Imagem.Picture.Bitmap:=gouraud_shading;
                    end;
                 end;
              end;
           end;
        end;
      4:begin
           Mensagem_label.Caption:=prepara_camera(Nx_edit.Text,Ny_edit.Text,
               Nz_edit.Text,Vx_edit.Text,Vy_edit.Text,Vz_edit.Text,Cx_edit.Text,
               Cy_edit.Text,Cz_edit.Text,d_edit.Text,hx_edit.Text,hy_edit.Text);
           if Mensagem_label.Caption[1]=' ' then begin
              Mensagem_label.Caption:=prepara_objeto(OdiRed_edit.Text,OdiGreen_edit.Text,
                  OdiBlue_edit.Text,OdeRed_edit.Text,OdeGreen_edit.Text,OdeBlue_edit.Text,
                  OsiRed_edit.Text,OsiGreen_edit.Text,OsiBlue_edit.Text,OseRed_edit.Text,
                  OseGreen_edit.Text,OseBlue_edit.Text,Kd_edit.Text,Ks_edit.Text,
                  rugosidade_edit.Text);
              if Mensagem_label.Caption[1]=' ' then begin
                 Mensagem_label.Caption:=prepara_cena(IaRed_edit.Text,IaGreen_edit.Text,
                                               IaBlue_edit.Text,Ka_edit.Text);
                 if Mensagem_label.Caption[1]=' ' then begin
                    atualiza_fonte_visivel;
                    Mensagem_label.Caption:=prepara_listas_das_fontes_de_luz(LFontes);
                    if Mensagem_label.Caption[1]=' ' then begin
                       mundial_para_vista;
                       mundial_para_vista_fontes_de_luz;
                       if z_buffer=nil then z_buffer:=ZBuffer.create;
                       z_buffer.limpar;
                       Imagem.Picture.Bitmap:=gouraud_shading_zbuffer;
                    end;
                 end;
              end;
           end;
        end;
      5:begin
           Mensagem_label.Caption:=prepara_camera(Nx_edit.Text,Ny_edit.Text,
               Nz_edit.Text,Vx_edit.Text,Vy_edit.Text,Vz_edit.Text,Cx_edit.Text,
               Cy_edit.Text,Cz_edit.Text,d_edit.Text,hx_edit.Text,hy_edit.Text);
           if Mensagem_label.Caption[1]=' ' then begin
              Mensagem_label.Caption:=prepara_objeto(OdiRed_edit.Text,OdiGreen_edit.Text,
                  OdiBlue_edit.Text,OdeRed_edit.Text,OdeGreen_edit.Text,OdeBlue_edit.Text,
                  OsiRed_edit.Text,OsiGreen_edit.Text,OsiBlue_edit.Text,OseRed_edit.Text,
                  OseGreen_edit.Text,OseBlue_edit.Text,Kd_edit.Text,Ks_edit.Text,
                  rugosidade_edit.Text);
              if Mensagem_label.Caption[1]=' ' then begin
                 Mensagem_label.Caption:=prepara_cena(IaRed_edit.Text,IaGreen_edit.Text,
                                               IaBlue_edit.Text,Ka_edit.Text);
                 if Mensagem_label.Caption[1]=' ' then begin
                    atualiza_fonte_visivel;
                    Mensagem_label.Caption:=prepara_listas_das_fontes_de_luz(LFontes);
                    if Mensagem_label.Caption[1]=' ' then begin
                       mundial_para_vista;
                       mundial_para_vista_fontes_de_luz;
                       if z_buffer=nil then z_buffer:=ZBuffer.create;
                       z_buffer.limpar;
                       Imagem.Picture.Bitmap:=phong_shading;
                    end;
                 end;
              end;
           end;
        end;
      6:begin
           if not TemTextura then
              Mensagem_label.Caption:='No h textura carregada.'
           else
              Mensagem_label.Caption:=prepara_camera(Nx_edit.Text,Ny_edit.Text,
                Nz_edit.Text,Vx_edit.Text,Vy_edit.Text,Vz_edit.Text,Cx_edit.Text,
                Cy_edit.Text,Cz_edit.Text,d_edit.Text,hx_edit.Text,hy_edit.Text);
           if Mensagem_label.Caption[1]=' ' then begin
              Mensagem_label.Caption:=prepara_objeto(OdiRed_edit.Text,OdiGreen_edit.Text,
                  OdiBlue_edit.Text,OdeRed_edit.Text,OdeGreen_edit.Text,OdeBlue_edit.Text,
                  OsiRed_edit.Text,OsiGreen_edit.Text,OsiBlue_edit.Text,OseRed_edit.Text,
                  OseGreen_edit.Text,OseBlue_edit.Text,Kd_edit.Text,Ks_edit.Text,
                  rugosidade_edit.Text);
              if Mensagem_label.Caption[1]=' ' then begin
                 Mensagem_label.Caption:=prepara_cena(IaRed_edit.Text,IaGreen_edit.Text,
                                               IaBlue_edit.Text,Ka_edit.Text);
                 if Mensagem_label.Caption[1]=' ' then begin
                    atualiza_fonte_visivel;
                    Mensagem_label.Caption:=prepara_listas_das_fontes_de_luz(LFontes);
                    if Mensagem_label.Caption[1]=' ' then begin
                       mundial_para_vista;
                       mundial_para_vista_fontes_de_luz;
                       mundial_para_vista_textura;
                       if z_buffer=nil then z_buffer:=ZBuffer.create;
                       z_buffer.limpar;
                       tFacei:=obter_int(tFacei_edit.Text,erro);
                       if erro then tFacei:=1;
                       tFacef:=obter_int(tFacef_edit.Text,erro);
                       if erro then tFacef:=NTriangulos;
                       Imagem.Picture.Bitmap:=tphong_shading;
                    end;
                 end;
              end;
           end;
        end;
      8:begin
           Mensagem_label.Caption:=prepara_camera(Nx_edit.Text,Ny_edit.Text,
               Nz_edit.Text,Vx_edit.Text,Vy_edit.Text,Vz_edit.Text,Cx_edit.Text,
               Cy_edit.Text,Cz_edit.Text,d_edit.Text,hx_edit.Text,hy_edit.Text);
           if Mensagem_label.Caption[1]=' ' then begin
              mundial_para_vista;
              Imagem.Picture.Bitmap:=wireframe_tetra;
           end;
        end;
   end;
end;

procedure TForm1.carrega_configuracao;
var F:textfile;
    erro:integer;
    Nx,Ny,Nz,Vx,Vy,Vz,Cx,Cy,Cz,d,hx,hy:real;
    Nl,i:integer;
    Iar,Iag,Iab,ka,Ilr,Ilg,Ilb,Px,Py,Pz:real;
    Odir,Odig,Odib,Osir,Osig,Osib,Oder,Odeg,Odeb,Oser,Oseg,Oseb,kd,ks,n:real;
    ListaOK:Boolean;
begin
   DecimalSeparator:='.';
   Renderizadores_radio.ItemIndex:=0;
   Eixos_de_rotacao_radio.ItemIndex:=0;
   LFontes:=TStringList.Create;
   ListaOK:=False;
   Fonte_visivel:=1;
   {$I-}
   AssignFile(F,'camera.txt');
   Reset(F);
   erro:=IOResult;
   if erro=0 then begin
      read(F, Nx,Ny,Nz,Vx,Vy,Vz,Cx,Cy,Cz,d,hx,hy);
      erro:=IOResult;
      if erro=0 then begin
         Nx_edit.Text:=FloatToStr(Nx);
         Ny_edit.Text:=FloatToStr(Ny);
         Nz_edit.Text:=FloatToStr(Nz);
         Vx_edit.Text:=FloatToStr(Vx);
         Vy_edit.Text:=FloatToStr(Vy);
         Vz_edit.Text:=FloatToStr(Vz);
         Cx_edit.Text:=FloatToStr(Cx);
         Cy_edit.Text:=FloatToStr(Cy);
         Cz_edit.Text:=FloatToStr(Cz);
         d_edit.Text:=FloatToStr(d);
         hx_edit.Text:=FloatToStr(hx);
         hy_edit.Text:=FloatToStr(hy);
         closefile(F);
      end;
   end;
   if erro<>0 then begin
      Rewrite(F);
      writeln(F,'0 0 1');
      writeln(F,'0 1 0');
      writeln(F,'0 0 0');
      writeln(F,'1');
      writeln(F,'1');
      writeln(F,'1 ');
      closefile(F);
   end;
   AssignFile(F,'cena.txt');
   Reset(F);
   erro:=IOResult;
   if erro=0 then begin
      read(F, Iar,Iag,Iab,ka,Nl,Ilr,Ilg,Ilb,Px,Py,Pz);
      erro:=IOResult;
      if erro=0 then begin
         IaRed_edit.Text:=FloatToStr(Iar);
         IaGreen_edit.Text:=FloatToStr(Iag);
         IaBlue_edit.Text:=FloatToStr(Iab);
         ka_edit.Text:=FloatToStr(ka);
         IlRed_edit.Text:=FloatToStr(Ilr);
         IlGreen_edit.Text:=FloatToStr(Ilg);
         IlBlue_edit.Text:=FloatToStr(Ilb);
         Plx_edit.Text:=FloatToStr(Px);
         Ply_edit.Text:=FloatToStr(Py);
         Plz_edit.Text:=FloatToStr(Pz);
         LFontes.Add(FloatToStr(Ilr));
         LFontes.Add(FloatToStr(Ilg));
         LFontes.Add(FloatToStr(Ilb));
         LFontes.Add(FloatToStr(Px));
         LFontes.Add(FloatToStr(Py));
         LFontes.Add(FloatToStr(Pz));
         for i:=2 to Nl do begin
            read(F, Ilr,Ilg,Ilb,Px,Py,Pz);
            erro:=IOResult;
            if erro<>0 then begin
               ListaOK:=True;
               break;
            end;
            LFontes.Add(FloatToStr(Ilr));
            LFontes.Add(FloatToStr(Ilg));
            LFontes.Add(FloatToStr(Ilb));
            LFontes.Add(FloatToStr(Px));
            LFontes.Add(FloatToStr(Py));
            LFontes.Add(FloatToStr(Pz));
         end;
         closefile(F);
      end
   end;
   if (erro<>0)then begin
      if  not ListaOK then begin
         LFontes.Add('255');
         LFontes.Add('255');
         LFontes.Add('255');
         LFontes.Add('0');
         LFontes.Add('0');
         LFontes.Add('0');
      end;
      Rewrite(F);
      writeln(F,'255 255 255');
      writeln(F,'0.5');
      writeln(F,'1');
      writeln(F,'255 255 255');
      writeln(F,'0 0 0');
      closefile(F);
   end;
   AssignFile(F,'objeto.txt');
   Reset(F);
   erro:=IOResult;
   if erro=0 then begin
      read(F,Odir,Odig,Odib,Oder,Odeg,Odeb,Osir,Osig,Osib,Oser,Oseg,Oseb,kd,ks,n);
      erro:=IOResult;
      if erro=0 then begin
         OdiRed_edit.Text:=FloatToStr(Odir);
         OdiGreen_edit.Text:=FloatToStr(Odig);
         OdiBlue_edit.Text:=FloatToStr(Odib);
         OdeRed_edit.Text:=FloatToStr(Oder);
         OdeGreen_edit.Text:=FloatToStr(Odeg);
         OdeBlue_edit.Text:=FloatToStr(Odeb);
         kd_edit.Text:=FloatToStr(kd);
         OsiRed_edit.Text:=FloatToStr(Osir);
         OsiGreen_edit.Text:=FloatToStr(Osig);
         OsiBlue_edit.Text:=FloatToStr(Osib);
         OseRed_edit.Text:=FloatToStr(Oser);
         OseGreen_edit.Text:=FloatToStr(Oseg);
         OseBlue_edit.Text:=FloatToStr(Oseb);
         ks_edit.Text:=FloatToStr(ks);
         rugosidade_edit.Text:=FloatToStr(n);
         closefile(F);
      end;
   end;
   if erro<>0 then begin
      Rewrite(F);
      writeln(F,'255 255 0');
      writeln(F,'255 255 0');
      writeln(F,'255 255 255');
      writeln(F,'255 255 255');
      writeln(F,'0.5');
      writeln(F,'0.5');
      writeln(F,'1');
      closefile(F);
   end
   {$I+}
end;

procedure TForm1.descarrega_configuracao(Sender: TObject);
var F:textfile;
    str1:string;
    erro,i:integer;
begin
   destruir_bitmap;
   prepara_listas;
   ChDir(diretorio);
   {$I-}
   AssignFile(F,'camera.txt');
   Rewrite(F);
   writeln(F,Nx_edit.Text,' ',Ny_edit.Text,' ',Nz_edit.Text);
   writeln(F,Vx_edit.Text,' ',Vy_edit.Text,' ',Vz_edit.Text);
   writeln(F,Cx_edit.Text,' ',Cy_edit.Text,' ',Cz_edit.Text);
   writeln(F,d_edit.Text);
   writeln(F,hx_edit.Text);
   writeln(F,hy_edit.Text);
   erro:=IOResult;
   closefile(F);
   if erro=0 then begin
      AssignFile(F,'cena.txt');
      Rewrite(F);
      writeln(F,IaRed_edit.Text,' ',IaGreen_edit.Text,' ',IaBlue_edit.Text);
      writeln(F,ka_edit.Text);
      writeln(F,(LFontes.count)div 6);
      for i:=0 to  LFontes.count-1 do begin
          write(F,LFontes[i],' ');
          if ((i+1) mod 3 = 0) then writeln(F);
      end;
      erro:=IOResult;
      closefile(F);
   end;
   if erro=0 then begin
      AssignFile(F,'objeto.txt');
      Rewrite(F);
      writeln(F,OdiRed_edit.Text,' ',OdiGreen_edit.Text,' ',OdiBlue_edit.Text);
      writeln(F,OdeRed_edit.Text,' ',OdeGreen_edit.Text,' ',OdeBlue_edit.Text);
      writeln(F,OsiRed_edit.Text,' ',OsiGreen_edit.Text,' ',OsiBlue_edit.Text);
      writeln(F,OseRed_edit.Text,' ',OseGreen_edit.Text,' ',OseBlue_edit.Text);
      writeln(F,kd_edit.Text);
      writeln(F,ks_edit.Text);
      writeln(F,rugosidade_edit.Text);
      closefile(F);
   end;
   {$I+}
   for i:=LFontes.Count-1 downto 0 do
      LFontes.Delete(i);
   LFontes.Free;
   if erro<>0 then
      Mensagem_label.Caption:='Erro ao se gravar arquivos de configurao.';
end;


constructor TForm1.create(AOwner:TComponent);
var i:integer;
begin
   inherited create(AOwner);
   Imagem.Picture.Bitmap:=prepara_imagem;
   carrega_configuracao;
   GetDir(0,diretorio);
   TemTextura:=False;
   tet_carregado:=False;
   for i:=1 to 80 do begin
      Tet_cor[i]:=Cor.create(128,128,128);
      Tet_habil[i]:=True;
   end;
   TModo.Checked:=False;
   THabil.Checked:=True;
   TetAtual:=1;
   DecimalSeparator:='.';
end;


procedure TForm1.CarregarObj_buttonClick(Sender: TObject);
var
     erro:Boolean;
begin
  OpenDialog1.Execute;
  FatorDilatacaoZ:=1;
  Mensagem_label.Caption:=carrega_objeto(OpenDialog1.FileName);
  if Mensagem_label.Caption[1]=' ' then begin
     NomeDoArquivo_label.Caption:=OpenDialog1.FileName;
     Desenhar_button.Enabled:=True;
     Label58.Caption:=IntToStr(Ntriangulos);
  end;
end;

//-------------------Editor de Fontes de Luz---------------------------------
procedure TForm1.atualiza_fonte_visivel;
var i,j:integer;
begin
   i:=(Fonte_visivel-1)*6;
   LFontes[i]:=(IlRed_edit.Text);
   LFontes[i+1]:=(IlGreen_edit.Text);
   LFontes[i+2]:=(IlBlue_edit.Text);
   LFontes[i+3]:=(Plx_edit.Text);
   LFontes[i+4]:=(Ply_edit.Text);
   LFontes[i+5]:=(Plz_edit.Text);
end;

procedure TForm1.FontePrevia_buttonClick(Sender: TObject);
var i,j:integer;
begin
   if Fonte_visivel>1 then begin
      i:=(Fonte_visivel-1)*6;
      LFontes[i]:=(IlRed_edit.Text);
      LFontes[i+1]:=(IlGreen_edit.Text);
      LFontes[i+2]:=(IlBlue_edit.Text);
      LFontes[i+3]:=(Plx_edit.Text);
      LFontes[i+4]:=(Ply_edit.Text);
      LFontes[i+5]:=(Plz_edit.Text);
      i:=i - 6;
      IlRed_edit.Text:=LFontes[i];
      IlGreen_edit.Text:=LFontes[i+1];
      IlBlue_edit.Text:=LFontes[i+2];
      Plx_edit.Text:=LFontes[i+3];
      Ply_edit.Text:=LFontes[i+4];
      Plz_edit.Text:=LFontes[i+5];
      Dec(Fonte_visivel);
      FontesDeLuz_groupbox.Caption:='Parmetros da Fonte de Luz de Nmero '+IntToStr(Fonte_visivel);
   end;
end;

procedure TForm1.FontePosterior_buttonClick(Sender: TObject);
var i:integer;
begin
   i:=Fonte_visivel*6;
   if i<LFontes.Count then begin
      i:=i - 6;
      LFontes[i]:=IlRed_edit.Text;
      LFontes[i+1]:=IlGreen_edit.Text;
      LFontes[i+2]:=IlBlue_edit.Text;
      LFontes[i+3]:=Plx_edit.Text;
      LFontes[i+4]:=Ply_edit.Text;
      LFontes[i+5]:=Plz_edit.Text;
      i:=i + 6;
      IlRed_edit.Text:=LFontes[i];
      IlGreen_edit.Text:=LFontes[i+1];
      IlBlue_edit.Text:=LFontes[i+2];
      Plx_edit.Text:=LFontes[i+3];
      Ply_edit.Text:=LFontes[i+4];
      Plz_edit.Text:=LFontes[i+5];
      Inc(Fonte_visivel);
      FontesDeLuz_groupbox.Caption:='Parmetros da Fonte de Luz de Nmero '+IntToStr(Fonte_visivel);
   end;
end;

procedure TForm1.AdicionarFonte_buttonClick(Sender: TObject);
var i:integer;
begin
   i:=(Fonte_visivel - 1)*6;
   LFontes[i]:=IlRed_edit.Text;
   LFontes[i+1]:=IlGreen_edit.Text;
   LFontes[i+2]:=IlBlue_edit.Text;
   LFontes[i+3]:=Plx_edit.Text;
   LFontes[i+4]:=Ply_edit.Text;
   LFontes[i+5]:=Plz_edit.Text;
   i:=i + 6;
   LFontes.Insert(i,'0');
   LFontes.Insert(i,'0');
   LFontes.Insert(i,'0');
   LFontes.Insert(i,'255');
   LFontes.Insert(i,'255');
   LFontes.Insert(i,'255');
   IlRed_edit.Text:=LFontes[i];
   IlGreen_edit.Text:=LFontes[i+1];
   IlBlue_edit.Text:=LFontes[i+2];
   Plx_edit.Text:=LFontes[i+3];
   Ply_edit.Text:=LFontes[i+4];
   Plz_edit.Text:=LFontes[i+5];
   Inc(Fonte_visivel);
   FontesDeLuz_groupbox.Caption:='Parmetros da Fonte de Luz de Nmero '+IntToStr(Fonte_visivel);
end;

procedure TForm1.RemoverFonte_buttonClick(Sender: TObject);
var i,qtd:integer;
begin
   qtd:=LFontes.Count;
   if qtd>6 then begin
      i:=(Fonte_visivel-1)*6;
      LFontes.Delete(i);
      LFontes.Delete(i);
      LFontes.Delete(i);
      LFontes.Delete(i);
      LFontes.Delete(i);
      LFontes.Delete(i);
      if i+6=qtd then begin
         i:=i-6;
         IlRed_edit.Text:=LFontes[i];
         IlGreen_edit.Text:=LFontes[i+1];
         IlBlue_edit.Text:=LFontes[i+2];
         Plx_edit.Text:=LFontes[i+3];
         Ply_edit.Text:=LFontes[i+4];
         Plz_edit.Text:=LFontes[i+5];
         Dec(Fonte_visivel);
      end
      else begin
         IlRed_edit.Text:=LFontes[i];
         IlGreen_edit.Text:=LFontes[i+1];
         IlBlue_edit.Text:=LFontes[i+2];
         Plx_edit.Text:=LFontes[i+3];
         Ply_edit.Text:=LFontes[i+4];
         Plz_edit.Text:=LFontes[i+5];
      end;
      FontesDeLuz_groupbox.Caption:='Parmetros da Fonte de Luz de Nmero '+IntToStr(Fonte_visivel);
   end;
end;


procedure TForm1.CarregarCtr_buttonClick(Sender: TObject);
begin
   if Centro<>nil then begin
      Centrox_edit.Text:=FloatToStr(Centro.xm);
      Centroy_edit.Text:=FloatToStr(Centro.ym);
      Centroz_edit.Text:=FloatToStr(Centro.zm);
   end;
end;

procedure TForm1.EfetuarRot_buttonClick(Sender: TObject);
var Cr_x,Cr_y,Cr_z,teta:real;
    s,c,dist:real;
    erro:Boolean;
begin
   Cr_x:=obter_real(Centrox_edit.Text,erro);
   if not erro then begin
       Cr_y:=obter_real(Centroy_edit.Text,erro);
       if not erro then begin
          Cr_z:=obter_real(Centroz_edit.Text,erro);
          if not erro then begin
             teta:=obter_real(Angulo_edit.Text,erro);
             if not erro then begin
                Mensagem_label.Caption:=prepara_camera(Nx_edit.Text,Ny_edit.Text,
                  Nz_edit.Text,Vx_edit.Text,Vy_edit.Text,Vz_edit.Text,Cx_edit.Text,
                  Cy_edit.Text,Cz_edit.Text,d_edit.Text,hx_edit.Text,hy_edit.Text);
                 if Mensagem_label.Caption[1]=' ' then begin
                    teta:= (teta/180.0)*3.141592653589;
                    if (Cr_x<>Camera1.C.xm)or(Cr_y<>Camera1.C.ym)or
                       (Cr_z<>Camera1.C.zm) then begin
                       Camera1.N.carrega(Cr_x-Camera1.C.xm,Cr_y-Camera1.C.ym,
                                         Cr_z-Camera1.C.zm);
                       dist:=Camera1.N.norma;
                       Camera1.carrega(Camera1.N,Camera1.V,Camera1.C,Camera1.d,
                                       Camera1.hx,Camera1.hy);
                       if Eixos_de_rotacao_radio.ItemIndex=0 then begin
                           Camera1.V.x:=Camera1.V.x*cos(teta)-Camera1.U.x*sin(teta);
                           Camera1.V.y:=Camera1.V.y*cos(teta)-Camera1.U.y*sin(teta);
                           Camera1.V.z:=Camera1.V.z*cos(teta)-Camera1.U.z*sin(teta);
                       end
                       else if Eixos_de_rotacao_radio.ItemIndex=1 then begin
                           Camera1.N.x:=Camera1.N.x*cos(teta)-Camera1.V.x*sin(teta);
                           Camera1.N.y:=Camera1.N.y*cos(teta)-Camera1.V.y*sin(teta);
                           Camera1.N.z:=Camera1.N.z*cos(teta)-Camera1.V.z*sin(teta);
                           Camera1.V.x:=Camera1.V.x*cos(teta)+Camera1.N.x*sin(teta);
                           Camera1.V.y:=Camera1.V.y*cos(teta)+Camera1.N.y*sin(teta);
                           Camera1.V.z:=Camera1.V.z*cos(teta)+Camera1.N.z*sin(teta);
                           Camera1.C.xm:=Cr_x - dist*Camera1.N.x;
                           Camera1.C.ym:=Cr_y - dist*Camera1.N.y;
                           Camera1.C.zm:=Cr_z - dist*Camera1.N.z;
                       end
                       else if Eixos_de_rotacao_radio.ItemIndex=2 then begin
                           Camera1.N.x:=Camera1.N.x*cos(teta)+Camera1.U.x*sin(teta);
                           Camera1.N.y:=Camera1.N.y*cos(teta)+Camera1.U.y*sin(teta);
                           Camera1.N.z:=Camera1.N.z*cos(teta)+Camera1.U.z*sin(teta);
                           Camera1.C.xm:=Cr_x - dist*Camera1.N.x;
                           Camera1.C.ym:=Cr_y - dist*Camera1.N.y;
                           Camera1.C.zm:=Cr_z - dist*Camera1.N.z;
                       end;
                    end
                    else begin
                       if Eixos_de_rotacao_radio.ItemIndex=0 then begin
                           Camera1.V.x:=Camera1.V.x*cos(teta)-Camera1.U.x*sin(teta);
                           Camera1.V.y:=Camera1.V.y*cos(teta)-Camera1.U.y*sin(teta);
                           Camera1.V.z:=Camera1.V.z*cos(teta)-Camera1.U.z*sin(teta);
                       end
                       else if Eixos_de_rotacao_radio.ItemIndex=1 then begin
                           Camera1.N.x:=Camera1.N.x*cos(teta)-Camera1.V.x*sin(teta);
                           Camera1.N.y:=Camera1.N.y*cos(teta)-Camera1.V.y*sin(teta);
                           Camera1.N.z:=Camera1.N.z*cos(teta)-Camera1.V.z*sin(teta);
                           Camera1.V.x:=Camera1.V.x*cos(teta)+Camera1.N.x*sin(teta);
                           Camera1.V.y:=Camera1.V.y*cos(teta)+Camera1.N.y*sin(teta);
                           Camera1.V.z:=Camera1.V.z*cos(teta)+Camera1.N.z*sin(teta);
                       end
                       else if Eixos_de_rotacao_radio.ItemIndex=2 then begin
                           Camera1.N.x:=Camera1.N.x*cos(teta)+Camera1.U.x*sin(teta);
                           Camera1.N.y:=Camera1.N.y*cos(teta)+Camera1.U.y*sin(teta);
                           Camera1.N.z:=Camera1.N.z*cos(teta)+Camera1.U.z*sin(teta);
                       end;
                    end;
                    Cx_edit.Text:=FloatToStr(Camera1.C.xm);
                    Cy_edit.Text:=FloatToStr(Camera1.C.ym);
                    Cz_edit.Text:=FloatToStr(Camera1.C.zm);
                    Nx_edit.Text:=FloatToStr(Camera1.N.x);
                    Ny_edit.Text:=FloatToStr(Camera1.N.y);
                    Nz_edit.Text:=FloatToStr(Camera1.N.z);
                    Vx_edit.Text:=FloatToStr(Camera1.V.x);
                    Vy_edit.Text:=FloatToStr(Camera1.V.y);
                    Vz_edit.Text:=FloatToStr(Camera1.V.z);
                 end;
             end
             else
                Mensagem_label.Caption:='ngulo em formato invlido.';
          end
          else
             Mensagem_label.Caption:='Coord. z do Centro Rot. em formato invlido.';
       end
       else
          Mensagem_label.Caption:='Coord. y do Centro Rot. em formato invlido.';
   end
   else
      Mensagem_label.Caption:='Coord. x do Centro Rot. em formato invlido.';

end;

procedure TForm1.CarregarFoco_buttonClick(Sender: TObject);
begin
   Centrox_edit.Text:=Cx_edit.Text;
   Centroy_edit.Text:=Cy_edit.Text;
   Centroz_edit.Text:=Cz_edit.Text;
end;

procedure TForm1.Button1Click(Sender: TObject);
var tmp:real;
    erro:Boolean;
begin
   tmp:=obter_real(Cx_edit.Text,erro);
   if not erro then begin
       tmp:=obter_real(Cy_edit.Text,erro);
       if not erro then begin
          tmp:=obter_real(Cz_edit.Text,erro);
          if not erro then begin
             Centrox_edit.Text:=FloatToStr(Camera1.C.xm + Camera1.d*Camera1.N.x);
             Centroy_edit.Text:=FloatToStr(Camera1.C.ym + Camera1.d*Camera1.N.y);
             Centroz_edit.Text:=FloatToStr(Camera1.C.zm + Camera1.d*Camera1.N.z);
          end
          else
             Mensagem_label.Caption:='Coord. z do Centro Rot. em formato invlido.';
       end
       else
          Mensagem_label.Caption:='Coord. y do Centro Rot. em formato invlido.';
   end
   else
      Mensagem_label.Caption:='Coord. x do Centro Rot. em formato invlido.';
end;


procedure TForm1.EfetuarRotDes_buttonClick(Sender: TObject);
begin
   EfetuarRot_buttonClick(Sender);
   if Mensagem_label.Caption[1]=' ' then
      Desenhar_buttonClick(Sender);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  OpenDialog1.Execute;
  Textura.LoadFromFile(OpenDialog1.FileName);
  Label56.Enabled:=True;
  TemTextura:=True;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
   SavePictureDialog1.Execute;
   salvar_imagem(SavePictureDialog1.FileName);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
   Plx_edit.Text:=Cx_edit.Text;
   Ply_edit.Text:=Cy_edit.Text;
   Plz_edit.Text:=Cz_edit.Text;
end;

procedure TForm1.TModoClick(Sender: TObject);
var F:textfile;
    erro,k,inutil:integer;

begin
   Mensagem_label.Caption:='                                                   ';
   if not Tet_modo then begin
      {$I-}
      AssignFile(F,'tetcores.txt');
      Reset(F);
      erro:=IOResult;
      if erro=0 then begin
         Tet_modo:=True;
         TModo.Checked:=true;
         k:=1;
         while k<=80 do begin
            read(F,inutil,Tet_cor[k].r,Tet_cor[k].g,Tet_cor[k].b);
            k:=k+1;
         end;
         closefile(F);
         TetCor_red.Text:=FloatToStr(Tet_cor[1].r);
         TetCor_green.Text:=FloatToStr(Tet_cor[1].g);
         TetCor_blue.Text:=FloatToStr(Tet_cor[1].b);
         THabil.Checked:=True;
      end
      else
         Mensagem_label.Caption:='Problemas com arquivo de cores.';
      {$I+}
   end
   else begin
      Tet_modo:=False;
      TModo.Checked:=False;
   end;
end;



procedure TForm1.Button5Click(Sender: TObject);
begin
   if TetAtual>1 then begin
      TetAtual:=TetAtual-1;
      TetCor_red.Text:=FloatToStr(Tet_cor[TetAtual].r);
      TetCor_green.Text:=FloatToStr(Tet_cor[TetAtual].g);
      TetCor_blue.Text:=FloatToStr(Tet_cor[TetAtual].b);
      THabil.Checked:=Tet_habil[TetAtual];
      NumTet.Caption:=IntToStr(TetAtual);
   end;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
   if TetAtual<80 then begin
      TetAtual:=TetAtual+1;
      TetCor_red.Text:=FloatToStr(Tet_cor[TetAtual].r);
      TetCor_green.Text:=FloatToStr(Tet_cor[TetAtual].g);
      TetCor_blue.Text:=FloatToStr(Tet_cor[TetAtual].b);
      THabil.Checked:=Tet_habil[TetAtual];
      NumTet.Caption:=IntToStr(TetAtual);
   end;
end;

procedure TForm1.TetCor_redChange(Sender: TObject);
begin
   Tet_cor[tetAtual].r:=StrToFloat(TetCor_red.Text);
end;

procedure TForm1.TetCor_greenChange(Sender: TObject);
begin
   Tet_cor[tetAtual].g:=StrToFloat(TetCor_green.Text);
end;

procedure TForm1.TetCor_blueChange(Sender: TObject);
begin
   Tet_cor[tetAtual].b:=StrToFloat(TetCor_blue.Text);
end;

procedure TForm1.THabilClick(Sender: TObject);
begin
   Tet_habil[TetAtual]:=THabil.Checked;
end;

procedure TForm1.Button7Click(Sender: TObject);
var i:integer;
begin
   for i:=1 to 80 do 
      Tet_habil[i]:=False;
   THabil.Checked:=False;
end;



procedure TForm1.Button8Click(Sender: TObject);
begin
   Tet_habil[1]:=True;
   Tet_habil[2]:=True;
   Tet_habil[3]:=True;
   Tet_habil[4]:=True;
   Tet_habil[11]:=True;
   Tet_habil[12]:=True;
   Tet_habil[13]:=True;
   Tet_habil[17]:=True;
   Tet_habil[18]:=True;
   Tet_habil[20]:=True;
   Tet_habil[21]:=True;
   Tet_habil[22]:=True;
   Tet_habil[23]:=True;
   Tet_habil[24]:=True;
   Tet_habil[31]:=True;
   Tet_habil[32]:=True;
   Tet_habil[33]:=True;
   Tet_habil[37]:=True;
   Tet_habil[38]:=True;
   Tet_habil[40]:=True;
   TetAtual:=1;
   TetCor_red.Text:=FloatToStr(Tet_cor[TetAtual].r);
   TetCor_green.Text:=FloatToStr(Tet_cor[TetAtual].g);
   TetCor_blue.Text:=FloatToStr(Tet_cor[TetAtual].b);
   THabil.Checked:=True;
   NumTet.Caption:=IntToStr(TetAtual);
end;

procedure TForm1.Button11Click(Sender: TObject);
begin
   Tet_habil[1]:=True;
   Tet_habil[5]:=True;
   Tet_habil[8]:=True;
   Tet_habil[10]:=True;
   Tet_habil[11]:=True;
   Tet_habil[14]:=True;
   Tet_habil[16]:=True;
   Tet_habil[17]:=True;
   Tet_habil[19]:=True;
   Tet_habil[20]:=True;
   Tet_habil[41]:=True;
   Tet_habil[45]:=True;
   Tet_habil[48]:=True;
   Tet_habil[50]:=True;
   Tet_habil[51]:=True;
   Tet_habil[54]:=True;
   Tet_habil[56]:=True;
   Tet_habil[57]:=True;
   Tet_habil[59]:=True;
   Tet_habil[60]:=True;
   TetAtual:=1;
   TetCor_red.Text:=FloatToStr(Tet_cor[TetAtual].r);
   TetCor_green.Text:=FloatToStr(Tet_cor[TetAtual].g);
   TetCor_blue.Text:=FloatToStr(Tet_cor[TetAtual].b);
   THabil.Checked:=True;
   NumTet.Caption:=IntToStr(TetAtual);
end;

procedure TForm1.Button12Click(Sender: TObject);
begin
   Tet_habil[4]:=True;
   Tet_habil[7]:=True;
   Tet_habil[9]:=True;
   Tet_habil[10]:=True;
   Tet_habil[13]:=True;
   Tet_habil[15]:=True;
   Tet_habil[16]:=True;
   Tet_habil[18]:=True;
   Tet_habil[19]:=True;
   Tet_habil[20]:=True;
   Tet_habil[64]:=True;
   Tet_habil[67]:=True;
   Tet_habil[69]:=True;
   Tet_habil[70]:=True;
   Tet_habil[73]:=True;
   Tet_habil[75]:=True;
   Tet_habil[76]:=True;
   Tet_habil[78]:=True;
   Tet_habil[79]:=True;
   Tet_habil[80]:=True;
   TetAtual:=4;
   TetCor_red.Text:=FloatToStr(Tet_cor[TetAtual].r);
   TetCor_green.Text:=FloatToStr(Tet_cor[TetAtual].g);
   TetCor_blue.Text:=FloatToStr(Tet_cor[TetAtual].b);
   THabil.Checked:=True;
   NumTet.Caption:=IntToStr(TetAtual);
end;

procedure TForm1.Button14Click(Sender: TObject);
begin
   if TetAtual<=70 then begin
      TetAtual:=TetAtual+10;
      TetCor_red.Text:=FloatToStr(Tet_cor[TetAtual].r);
      TetCor_green.Text:=FloatToStr(Tet_cor[TetAtual].g);
      TetCor_blue.Text:=FloatToStr(Tet_cor[TetAtual].b);
      THabil.Checked:=Tet_habil[TetAtual];
      NumTet.Caption:=IntToStr(TetAtual);
   end;
end;

procedure TForm1.Button15Click(Sender: TObject);
begin
   if TetAtual>10 then begin
      TetAtual:=TetAtual-10;
      TetCor_red.Text:=FloatToStr(Tet_cor[TetAtual].r);
      TetCor_green.Text:=FloatToStr(Tet_cor[TetAtual].g);
      TetCor_blue.Text:=FloatToStr(Tet_cor[TetAtual].b);
      THabil.Checked:=Tet_habil[TetAtual];
      NumTet.Caption:=IntToStr(TetAtual);
   end;
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
   Tet_habil[21]:=True;
   Tet_habil[25]:=True;
   Tet_habil[28]:=True;
   Tet_habil[30]:=True;
   Tet_habil[31]:=True;
   Tet_habil[34]:=True;
   Tet_habil[36]:=True;
   Tet_habil[37]:=True;
   Tet_habil[39]:=True;
   Tet_habil[40]:=True;
   Tet_habil[41]:=True;
   Tet_habil[42]:=True;
   Tet_habil[43]:=True;
   Tet_habil[44]:=True;
   Tet_habil[51]:=True;
   Tet_habil[52]:=True;
   Tet_habil[53]:=True;
   Tet_habil[57]:=True;
   Tet_habil[58]:=True;
   Tet_habil[60]:=True;
   TetAtual:=21;
   TetCor_red.Text:=FloatToStr(Tet_cor[TetAtual].r);
   TetCor_green.Text:=FloatToStr(Tet_cor[TetAtual].g);
   TetCor_blue.Text:=FloatToStr(Tet_cor[TetAtual].b);
   THabil.Checked:=True;
   NumTet.Caption:=IntToStr(TetAtual);
end;

procedure TForm1.Button10Click(Sender: TObject);
begin
   Tet_habil[44]:=True;
   Tet_habil[47]:=True;
   Tet_habil[49]:=True;
   Tet_habil[50]:=True;
   Tet_habil[53]:=True;
   Tet_habil[55]:=True;
   Tet_habil[56]:=True;
   Tet_habil[58]:=True;
   Tet_habil[59]:=True;
   Tet_habil[60]:=True;
   Tet_habil[61]:=True;
   Tet_habil[65]:=True;
   Tet_habil[68]:=True;
   Tet_habil[70]:=True;
   Tet_habil[71]:=True;
   Tet_habil[74]:=True;
   Tet_habil[76]:=True;
   Tet_habil[77]:=True;
   Tet_habil[79]:=True;
   Tet_habil[80]:=True;
   TetAtual:=44;
   TetCor_red.Text:=FloatToStr(Tet_cor[TetAtual].r);
   TetCor_green.Text:=FloatToStr(Tet_cor[TetAtual].g);
   TetCor_blue.Text:=FloatToStr(Tet_cor[TetAtual].b);
   THabil.Checked:=True;
   NumTet.Caption:=IntToStr(TetAtual);
end;

procedure TForm1.Button13Click(Sender: TObject);
begin
   Tet_habil[24]:=True;
   Tet_habil[27]:=True;
   Tet_habil[29]:=True;
   Tet_habil[30]:=True;
   Tet_habil[33]:=True;
   Tet_habil[35]:=True;
   Tet_habil[36]:=True;
   Tet_habil[38]:=True;
   Tet_habil[39]:=True;
   Tet_habil[40]:=True;
   Tet_habil[61]:=True;
   Tet_habil[62]:=True;
   Tet_habil[63]:=True;
   Tet_habil[64]:=True;
   Tet_habil[71]:=True;
   Tet_habil[72]:=True;
   Tet_habil[73]:=True;
   Tet_habil[77]:=True;
   Tet_habil[78]:=True;
   Tet_habil[80]:=True;
   TetAtual:=24;
   TetCor_red.Text:=FloatToStr(Tet_cor[TetAtual].r);
   TetCor_green.Text:=FloatToStr(Tet_cor[TetAtual].g);
   TetCor_blue.Text:=FloatToStr(Tet_cor[TetAtual].b);
   THabil.Checked:=True;
   NumTet.Caption:=IntToStr(TetAtual);
end;

end.
