unit uBitMap;

interface
uses Classes,Windows,Graphics;


Const  Largura = 600;
       Altura = 600;
       InicioY = 8;
       InicioX = 424;
       meia_altura = Altura div 2;
       meia_largura = Largura div 2;

Var
    Bitmap,Textura:TBitMap;


procedure destruir_bitmap;
function prepara_imagem:TBitmap;
procedure salvar_imagem(nome:string);


implementation
//-----------------------------BitMap (prep)------------------

function prepara_imagem:TBitmap;
var i,j:integer;
begin
   if Bitmap=nil then begin
      Bitmap:=TBitmap.Create;
      Bitmap.Width:=Largura;
      Bitmap.Height:=Altura;
      Textura:= TBitmap.Create;
   end;
   Bitmap.Canvas.Brush.Color:=RGB(0,0,0);
   Bitmap.Canvas.Rectangle(1,1,Largura,Altura);
   result:=Bitmap;
end;

procedure salvar_imagem(nome:string);
begin
   Bitmap.SaveToFile(nome);
end;


procedure destruir_bitmap;
begin
   Bitmap.Free;
end;

end.
